function [A,f,Aeq,beq]=Displacement_distribution(x0,alldofs,...
    phi,modedofs,NumM,BEAMS,modefree,iK,jK,standard,d3,Beams,NumMode)

%%%%%%%%%%%%%%%%%%condensed parameterized stiffness matrix%%%%%%%%%%%%%%%%%
%parameterized stiffness matrix (14)
standard2=standard.*kron(x0,ones(6,6))';
K=sparse(iK,jK,standard2);      
K=(K+K')/2; 
%partitioned stiffness matrix (1)
Kbb=K(modedofs,modedofs);
Kbu=K(modedofs,modefree);
Kub=K(modefree,modedofs);
Kuu=K(modefree,modefree);
%condensed stiffness matrix (2)
invKuu=Kuu\Kub;
CondK=Kbb-Kbu*invKuu;

%%%%%Sub-problem 1: calculation of the orthonormal base and expansion%%%%%%
%calculation of the orthonormal base (21)-(24)
c=(phi'*CondK)';
[Q,~]=qr(c); 
n=length(Q); r=rank(c); J=zeros(n,n);
Jnminr=eye(n-r);
J(r+1:n,r+1:n)=Jnminr;
G=J*Q'*CondK*Q*J;
G22=G(r+1:n,r+1:n);
[D,L]=eig(G22);
[~,ind]=sort(diag(L));
Dsort=D(:,ind);
x=Q*vertcat(zeros(r,n-r),Jnminr)*Dsort;
Psi=horzcat(phi,x); %orthonormal base (20)

%expansion (25)
Modenew=zeros(length(alldofs),length(Psi(1,:)));
Modenew(modedofs,:)=Psi(:,:);
Modenew(modefree,:)=-invKuu*Psi(:,:);
%%%%%%%%%%%%%%%%%%%%objective function and restrictions%%%%%%%%%%%%%%%%%%%%
Modenew1=real(reshape(Modenew(BEAMS',1:NumM+NumMode)',NumM+NumMode,6,Beams));
%objective function (26)
f=reshape(-pagemtimes(pagemtimes(Modenew1(NumMode+1,:,:),d3(:,:,:)),'none',...
    Modenew1(NumMode+1,:,:),'transpose'),Beams,1);
%restriction (27) and (28)
A=0.5*pagemtimes(pagemtimes(Modenew1(1:NumMode,:,:),d3(:,:,:)),'none',...
    Modenew1(1:NumMode,:,:),'transpose');
if NumMode==1
    A=reshape(A(1,1,:),1,Beams);
    Aeq=[];
    beq=[];
elseif NumMode==2
    A=vertcat(reshape(A(1,1,:),1,Beams),reshape(A(2,2,:),1,Beams));
    Aeq=reshape(pagemtimes(pagemtimes(Modenew1(1,:,:),d3(:,:,:)),'none',...
        Modenew1(2,:,:),'transpose'),1,Beams);
    beq=0;
else
    A=vertcat(reshape(A(1,1,:),1,Beams),reshape(A(2,2,:),1,Beams),...
        reshape(A(3,3,:),1,Beams));
    Aeq(1,:)=reshape(pagemtimes(pagemtimes(Modenew1(1,:,:),d3(:,:,:)),'none',...
        Modenew1(2,:,:),'transpose'),1,Beams);
    Aeq(2,:)=reshape(pagemtimes(pagemtimes(Modenew1(1,:,:),d3(:,:,:)),'none',...
        Modenew1(3,:,:),'transpose'),1,Beams);
    Aeq(3,:)=reshape(pagemtimes(pagemtimes(Modenew1(2,:,:),d3(:,:,:)),'none',...
        Modenew1(3,:,:),'transpose'),1,Beams);
    beq=[0 0 0];
end
%restriction (29)
for j=NumMode+2:NumM+NumMode
    A(j-1,:)=reshape(pagemtimes(pagemtimes(Modenew1(NumMode+1,:,:),d3(:,:,:)),...
        'none',Modenew1(NumMode+1,:,:),'transpose')-pagemtimes(pagemtimes(...
        Modenew1(j,:,:),d3(:,:,:)),'none',Modenew1(j,:,:),'transpose'),...
        Beams,1);
end
end