function [D,L]=Plotdef(x0,ZUO,PuKo,freedofs,alldofs,h,bb,modedofs,Di,...
    beams,modefree,standard,iK,jK)
%%%%%%%%%%%%%%%%%%condensed parameterized stiffness matrix%%%%%%%%%%%%%%%%%
%parameterized stiffness matrix
standard2=standard.*kron(x0,ones(6,6))';
K=sparse(iK,jK,standard2);      
K=(K+K')/2; 
%partitioned stiffness matrix (1)
Kbb=K(modedofs,modedofs);
Kbu=K(modedofs,modefree);
Kub=K(modefree,modedofs);
Kuu=full(K(modefree,modefree));
%condensed stiffness matrix (2)
invKuu=Kuu\Kub;
CondK=(Kbb-Kbu*invKuu);
[D,L]=eig(CondK);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Plot%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
U(alldofs)=0; 
F(alldofs)=0; 
% %the mechanism can also be displayed in deformed configuration by 
% %specifying a load
% F(614)=-10000;
U(freedofs)=(K(freedofs,freedofs))\F(freedofs)'; 
Thickness=x0(:).*Di;
for i=1:beams 
    plotx=[PuKo(ZUO(i,2),2)+U(3*ZUO(i,2)-2);...
    PuKo(ZUO(i,3),2)+U(3*ZUO(i,3)-2)]; 
    ploty=[PuKo(ZUO(i,2),3)+U(3*ZUO(i,2)-1);...
    PuKo(ZUO(i,3),3)+U(3*ZUO(i,3)-1)]; 
    if Thickness(i)>0.0001 
        plot(plotx,ploty,'LineWidth',Thickness(i),'Color',[0 0 0]); 
    end
    grid off 
    hold on 
end
axis equal 
xlim([0,bb+10]) 
ylim([0,h+10]) 
title({'Optimization result'}); 
xlabel('[mm]') 
ylabel('[mm]') 
set(gca,'FontSize',12,'FontName','Arial');
end
