function [Standardmatrix]=Standardmatrices(ZUO,PuKo,width,thick,E)

%calculation of beam parameters
thickness_vector=thick*ones(length(ZUO),1);
EI=E*thickness_vector.^3*width/12;
EA=E*thickness_vector.*width;

Beams=length(ZUO);
Nodes=length(PuKo);

%%%%%%%%%%%%%%%%%%%%%%%%%global calculations%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%calculation of beam length
for i=1:Beams
    LL(i)=((PuKo(ZUO(i,3),2)-PuKo(ZUO(i,2),2))^2+(PuKo(ZUO(i,3),3)...
        -PuKo(ZUO(i,2),3))^2)^0.5;
end
%calculation of the rotation of the beams
for i=1:Beams
    y(i+1)=PuKo(ZUO(i,3),3);
    y(i)=PuKo(ZUO(i,2),3);
    x(i+1)=PuKo(ZUO(i,3),2);
    x(i)=PuKo(ZUO(i,2),2);
    if (y(i+1)>y(i)) && (x(i+1)>x(i))
        v(i)=atan((y(i)-y(i+1))/(x(i)-x(i+1)));
    end
    if (y(i+1)>y(i)) && (x(i+1)<x(i))
        v(i)=pi+atan((y(i)-y(i+1))/(x(i)-x(i+1)));
    end
    if (y(i+1)<y(i)) && (x(i+1)<x(i))
        v(i)=pi+atan((y(i)-y(i+1))/(x(i)-x(i+1)));
    end
    if (y(i+1)<y(i)) && (x(i+1)>x(i))
        v(i)=atan((y(i)-y(i+1))/(x(i)-x(i+1)));
    end
    if (y(i+1)==y(i)) && (x(i+1)>x(i))
    v(i)=0;
    end
    if (y(i+1)==y(i)) && (x(i+1)<x(i))
    v(i)=pi;
    end
    if (y(i+1)<y(i)) && (x(i+1)==x(i))
    v(i)=pi+pi/2;
    end
    if (y(i+1)>y(i)) && (x(i+1)==x(i))
    v(i)=pi/2;
    end
end
%Setting up the allocation matrices
for i=1:Beams
    A=zeros(6,3*Nodes);
    for j=1:2
    A((3*(j-1)+1),(3*(ZUO(i,1+j))-2))=1;
    A((3*(j-1)+2),(3*(ZUO(i,1+j))-2)+1)=1;
    A((3*(j-1)+3),(3*(ZUO(i,1+j))-2)+2)=1;
    end
    cellA{1,i}=A;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%local calculations%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%coordinate transformation
for i=1:Beams
    D=zeros(6,6);        
    D=[cos(-v(i)) -sin(-v(i)) 0 0 0 0;...
        sin(-v(i)) cos(-v(i)) 0 0 0 0;...
        0 0 1 0 0 0;...
        0 0 0 cos(-v(i)) -sin(-v(i)) 0;...
        0 0 0 sin(-v(i)) cos(-v(i)) 0;...
        0 0 0 0 0 1];
    cellD{1,i}=D;
end
%B-matrix
for i=1:Beams
B=[-1 0 0;...
    0 -1 0;...
    0 -LL(i) -1;...
    1 0 0;...
    0 1 0;...
    0 0 1];
cellB{1,i}=B';
end
%local stiffness matrix
for i=1:Beams
Cs=[EA(i)/LL(i) 0 0;...
    0 12*EI(i)/LL(i)^3 -6*EI(i)/LL(i)^2;...
    0 -6*EI(i)/LL(i)^2 4*EI(i)/LL(i)];
cellCs{1,i}=Cs;
end
for i=1:Beams
Standardmatrix{1,i}=cellD{1,i}'*cellB{1,i}'*cellCs{1,i}*cellB{1,i}*...
    cellD{1,i};
end

